using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Web_VCnet
{
	/// <summary>
	/// Summary description for Dataweb_personal.
	/// </summary>
	public class Dataweb_personal : System.Web.UI.Page
	{
		protected System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		protected System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		protected System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		protected System.Data.OleDb.OleDbConnection oleDbConnection1;
		protected System.Data.OleDb.OleDbDataAdapter oleDbDataAdapter1;
		protected Web_VCnet.Dataweb_personaldset objDataweb_personaldset;
		protected System.Web.UI.WebControls.DataGrid masterDataGrid;
		protected System.Web.UI.WebControls.Label lbnavigation;
		protected System.Web.UI.WebControls.Button LastPage;
		protected System.Web.UI.WebControls.Button NextPage;
		protected System.Web.UI.WebControls.Button PreviousPage;
		protected System.Web.UI.WebControls.Button FirstPage;
		protected System.Web.UI.WebControls.HyperLink HyperLink1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Panel Panel1;
		protected System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if (Session["mydatset"] == null) 
			{
				try 
				{
					this.LoadDataSet();
					this.masterDataGrid.SelectedIndex = -1;
					this.masterDataGrid.DataBind();
				}
				catch (System.Exception eLoad) 
				{
					this.Response.Write(eLoad.Message);
				}

				Session["mydataset"] = this.objDataweb_personaldset;
            
				// Enable paging.
				masterDataGrid.AllowPaging = true;
				masterDataGrid.PageSize = 5;
																									   
				if (!Page.IsPostBack)
				{
					FirstPage_Click(sender, e);
				}
			}			
			else
			{
				this.objDataweb_personaldset = ((Web_VCnet.Dataweb_personaldset)(Session["mydatset"]));
			
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbDataAdapter1 = new System.Data.OleDb.OleDbDataAdapter();
			this.objDataweb_personaldset = new Web_VCnet.Dataweb_personaldset();
			((System.ComponentModel.ISupportInitialize)(this.objDataweb_personaldset)).BeginInit();
			this.masterDataGrid.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.masterDataGrid_CancelCommand);
			this.masterDataGrid.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.masterDataGrid_EditCommand);
			this.masterDataGrid.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.masterDataGrid_UpdateCommand);
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT birth, country, first_name, name, personal_id, sex FROM personal";
			this.oleDbSelectCommand1.Connection = this.oleDbConnection1;
			// 
			// oleDbConnection1
			// 
			this.oleDbConnection1.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""C:\Documents and Settings\GERARD  ZOUEIN\VSWebCache\IBM-B5CA7BA5A3A\Web_VCnet\web_VCnet.mdb"";Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False";
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO personal(birth, country, first_name, name, sex) VALUES (?, ?, ?, ?, ?" +
				")";
			this.oleDbInsertCommand1.Connection = this.oleDbConnection1;
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("birth", System.Data.OleDb.OleDbType.DBDate, 0, "birth"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("country", System.Data.OleDb.OleDbType.VarWChar, 25, "country"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("first_name", System.Data.OleDb.OleDbType.VarWChar, 50, "first_name"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("name", System.Data.OleDb.OleDbType.VarWChar, 50, "name"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("sex", System.Data.OleDb.OleDbType.VarWChar, 25, "sex"));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = @"UPDATE personal SET birth = ?, country = ?, first_name = ?, name = ?, sex = ? WHERE (personal_id = ?) AND (birth = ? OR ? IS NULL AND birth IS NULL) AND (country = ? OR ? IS NULL AND country IS NULL) AND (first_name = ? OR ? IS NULL AND first_name IS NULL) AND (name = ? OR ? IS NULL AND name IS NULL) AND (sex = ? OR ? IS NULL AND sex IS NULL)";
			this.oleDbUpdateCommand1.Connection = this.oleDbConnection1;
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("birth", System.Data.OleDb.OleDbType.DBDate, 0, "birth"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("country", System.Data.OleDb.OleDbType.VarWChar, 25, "country"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("first_name", System.Data.OleDb.OleDbType.VarWChar, 50, "first_name"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("name", System.Data.OleDb.OleDbType.VarWChar, 50, "name"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("sex", System.Data.OleDb.OleDbType.VarWChar, 25, "sex"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_personal_id", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "personal_id", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_birth", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "birth", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_birth1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "birth", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_country", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "country", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_country1", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "country", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_first_name", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "first_name", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_first_name1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "first_name", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_name", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "name", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_name1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "name", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_sex", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "sex", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_sex1", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "sex", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = @"DELETE FROM personal WHERE (personal_id = ?) AND (birth = ? OR ? IS NULL AND birth IS NULL) AND (country = ? OR ? IS NULL AND country IS NULL) AND (first_name = ? OR ? IS NULL AND first_name IS NULL) AND (name = ? OR ? IS NULL AND name IS NULL) AND (sex = ? OR ? IS NULL AND sex IS NULL)";
			this.oleDbDeleteCommand1.Connection = this.oleDbConnection1;
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_personal_id", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "personal_id", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_birth", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "birth", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_birth1", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "birth", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_country", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "country", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_country1", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "country", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_first_name", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "first_name", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_first_name1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "first_name", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_name", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "name", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_name1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "name", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_sex", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "sex", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_sex1", System.Data.OleDb.OleDbType.VarWChar, 25, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "sex", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbDataAdapter1
			// 
			this.oleDbDataAdapter1.DeleteCommand = this.oleDbDeleteCommand1;
			this.oleDbDataAdapter1.InsertCommand = this.oleDbInsertCommand1;
			this.oleDbDataAdapter1.SelectCommand = this.oleDbSelectCommand1;
			this.oleDbDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "personal", new System.Data.Common.DataColumnMapping[] {
																																																					new System.Data.Common.DataColumnMapping("birth", "birth"),
																																																					new System.Data.Common.DataColumnMapping("country", "country"),
																																																					new System.Data.Common.DataColumnMapping("first_name", "first_name"),
																																																					new System.Data.Common.DataColumnMapping("name", "name"),
																																																					new System.Data.Common.DataColumnMapping("personal_id", "personal_id"),
																																																					new System.Data.Common.DataColumnMapping("sex", "sex")})});
			this.oleDbDataAdapter1.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// objDataweb_personaldset
			// 
			this.objDataweb_personaldset.DataSetName = "Dataweb_personaldset";
			this.objDataweb_personaldset.Locale = new System.Globalization.CultureInfo("en-US");
			this.LastPage.Click += new System.EventHandler(this.LastPage_Click);
			this.NextPage.Click += new System.EventHandler(this.NextPage_Click);
			this.PreviousPage.Click += new System.EventHandler(this.PreviousPage_Click);
			this.FirstPage.Click += new System.EventHandler(this.FirstPage_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			((System.ComponentModel.ISupportInitialize)(this.objDataweb_personaldset)).EndInit();

		}
		#endregion

		public void LoadDataSet()
		{
			// Create a new dataset to hold the records returned from the call to FillDataSet.
			// A temporary dataset is used because filling the existing dataset would
			// require the databindings to be rebound.
			Web_VCnet.Dataweb_personaldset objDataSetTemp;
			objDataSetTemp = new Web_VCnet.Dataweb_personaldset();
			try 
			{
				// Attempt to fill the temporary dataset.
				this.FillDataSet(objDataSetTemp);
			}
			catch (System.Exception eFillDataSet) 
			{
				// Add your error handling code here.
				throw eFillDataSet;
			}
			try 
			{
				// Empty the old records from the dataset.
				objDataweb_personaldset.Clear();
				// Merge the records into the main dataset.
				objDataweb_personaldset.Merge(objDataSetTemp);
			}
			catch (System.Exception eLoadMerge) 
			{
				// Add your error handling code here.
				throw eLoadMerge;
			}

		}


		public void FillDataSet(Web_VCnet.Dataweb_personaldset dataSet)
		{
			// Turn off constraint checking before the dataset is filled.
			// This allows the adapters to fill the dataset without concern
			// for dependencies between the tables.
			dataSet.EnforceConstraints = false;
			try 
			{
				// Open the connection.
				this.oleDbConnection1.Open();
				// Attempt to fill the dataset through the OleDbDataAdapter1.
				this.oleDbDataAdapter1.Fill(dataSet);
			}
			catch (System.Exception fillException) 
			{
				// Add your error handling code here.
				throw fillException;
			}
			finally 
			{
				// Turn constraint checking back on.
				dataSet.EnforceConstraints = true;
				// Close the connection whether or not the exception was thrown.
				this.oleDbConnection1.Close();
			}

		}

	  //*****************************     Navigation ...
		private void FirstPage_Click(object sender, System.EventArgs e)
		{
			masterDataGrid.CurrentPageIndex = 0;
	
			//Enabled buttons and bind the data
			show_Button(masterDataGrid.CurrentPageIndex);
		}

		//Enabled buttons and bind the data
		private void show_Button( int vCurrentPage)
		{
			int vcpage = vCurrentPage + 1;
			int vPagecount;
			
			if (vCurrentPage == 0)
			{
				FirstPage.Enabled = false;
				PreviousPage.Enabled = false;
				NextPage.Enabled = true;
				LastPage.Enabled = true;
				goto pt1;
			}
			else
			{
				if (vCurrentPage == (masterDataGrid.PageCount - 1))
				{
        
					FirstPage.Enabled = true;
					PreviousPage.Enabled = true;
					NextPage.Enabled = false;
					LastPage.Enabled = false;
					goto pt1;
				}
				else
				{
					FirstPage.Enabled = true;
					PreviousPage.Enabled = true;
					NextPage.Enabled = true;
					LastPage.Enabled = true;
				}
			}
			pt1:

			masterDataGrid.DataBind();

			vPagecount = masterDataGrid.PageCount;
			this.lbnavigation.Text = "Page :  " + System.Convert.ToString(vcpage) + "    of    " + System.Convert.ToString(vPagecount) + "       ............       info: Page size = 5";
       
		}

		private void PreviousPage_Click(object sender, System.EventArgs e)
		{
			masterDataGrid.CurrentPageIndex = Math.Max(0, masterDataGrid.CurrentPageIndex - 1);
	
			//Enabled buttons and bind the data
			show_Button(masterDataGrid.CurrentPageIndex);
		}

		private void NextPage_Click(object sender, System.EventArgs e)
		{
			masterDataGrid.CurrentPageIndex = Math.Min(masterDataGrid.PageCount - 1, masterDataGrid.CurrentPageIndex + 1);
	
			//Enabled buttons and bind the data
			show_Button(masterDataGrid.CurrentPageIndex);
		}

		private void LastPage_Click(object sender, System.EventArgs e)
		{
			masterDataGrid.CurrentPageIndex = masterDataGrid.PageCount - 1;
	
			//Enabled buttons and bind the data
			show_Button(masterDataGrid.CurrentPageIndex);
		}

		// *****************************  Edit, Update, Cancel
		private void masterDataGrid_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.masterDataGrid.EditItemIndex = e.Item.ItemIndex;
			this.masterDataGrid.DataBind();
		}

		private void masterDataGrid_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			this.masterDataGrid.EditItemIndex = -1;
			this.masterDataGrid.DataBind();
		}

		private void masterDataGrid_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string vfirstname;
			string vname;
			string vsex;
			string vcountry;

			// Gets the value of the key field of the row being updated
			string key = masterDataGrid.DataKeys[e.Item.ItemIndex].ToString();

			// Gets get the value of the controls (textboxes) that the user
			// updated. The DataGrid columns are exposed as the Cells collection.
			// Each cell has a collection of controls. In this case, there is only    one 
			// control in each cell -- a TextBox control. To get its value,
			// you copy the TextBox to a local instance (which requires casting)
			// and extract its Text property.
			//
			// The first column -- Cells(0) -- contains the Update and Cancel buttons.
			System.Web.UI.WebControls.TextBox tb;

			// Gets the value the TextBox control in the 2nd column
			tb = ((System.Web.UI.WebControls.TextBox)(e.Item.Cells[1].Controls[0]));
			vfirstname = tb.Text;

			// Gets the value the TextBox control in the 3th column
			tb = ((System.Web.UI.WebControls.TextBox)(e.Item.Cells[2].Controls[0]));
			vname = tb.Text;

			// Gets the value the TextBox control in the 4th column
			tb = ((System.Web.UI.WebControls.TextBox)(e.Item.Cells[3].Controls[0]));
			vsex = tb.Text;

			// Gets the value the TextBox control in the 5th column
			tb = ((System.Web.UI.WebControls.TextBox)(e.Item.Cells[4].Controls[0]));
			vcountry = tb.Text;

			// Finds the row in the dataset table that matches the 
			// one the user updated in the grid. This example uses a 
			// special Find method defined for the typed dataset, which
			// returns a reference to the row.
			Dataweb_personaldset.personalRow r;
			r = objDataweb_personaldset.personal.FindBypersonal_id(int.Parse(key));

			// Updates the dataset table.
			r.first_name = vfirstname;;
			r.name = vname;
			r.sex = vsex;
			r.country = vcountry;			
			
			// Calls a OLE statement to update the database from the dataset
			this.oleDbDataAdapter1.Update(this.objDataweb_personaldset, "personal");

			// Takes the DataGrid row out of editing mode
			masterDataGrid.EditItemIndex = -1;

			// Refreshes the grid
			masterDataGrid.DataBind();

		}
	}
}
